#!/bin/sh

run_test() #program, description
{
	echo
	echo "-- Running $1 ($2)"
	$1
	if [ 0 -ne $? ]; then echo "FAILED"; fi
}

perform_test()
{
	set -e
	$GDC -shared -o libdll1.dll dllmain.d
	$GDC -shared -o libdll2.dll plaindll.d
	$GDC -o test1.exe test1.d
	$GDC -o test2.exe test2.d
	$GCC -o test1c.exe test1.c
	$GCC -o test2c.exe test2.c
	$GCC -o test3c.exe -L. -ldll1 test3.c
	$GCC -o test4c.exe -L. -ldll2 test4.c
	set +e
	
	run_test test1.exe "D Host, LoadLibrary, DllMain"
	run_test test2.exe "D Host, LoadLibrary, init()"
	run_test test1c.exe "C Host, LoadLibrary, DllMain"
	run_test test2c.exe "C Host, LoadLibrary, init()"
	run_test test3c.exe "C Host, static, DllMain"
	run_test test4c.exe "C Host, static, init()"
}

echo "== Testing 32 bit =="
GCC="mingw32-gcc.exe -m32"
GDC="i686-pc-mingw32-gdc.exe -m32"
perform_test
echo

echo "== Testing 64 bit =="
GCC="x86_64-w64-mingw32-gcc.exe -m64"
GDC="x86_64-w64-mingw32-gdc.exe -m64"
perform_test
