#include <stdio.h>
#include <windows.h>

typedef int (*init_t)();

int main()
{
	HMODULE dll2 = LoadLibraryA("libdll2.dll");
	if( !dll2 ){
		printf("Error loading dll2: %d\n", GetLastError());
		return 1;
	}

	printf("Successfully loaded dll2\n");
	
	init_t init = (init_t)GetProcAddress(dll2, "init");
	if( !init ){
		printf("Failed to get init() from dll2\n");
		return 1;
	}
		
	if( init() != 0 ){
		printf("Error initializing dll2\n");
		return 1;
	}
	
	printf("Successfully initialized dll2\n");
	return 0;
}
